<script setup>
import { store } from "quasar/wrappers";
import { useTaskStore } from "src/stores/task";
import { ref, onMounted, computed } from "vue";

const props = defineProps({
  task: {
    type: Object,
  },
});

const emits = defineEmits({
  closeDialog() {
    return true;
  },
});

const task = ref(
  props.task ?? {
    name: "",
    description: "",
    is_done: false,
  }
);
const taskStore = useTaskStore();

const deleteTask = () => {
  taskStore.deleteTask(props.task.id);
  emits("closeDialog");
};

const onSubmit = () => {
  if (!isEditing.value) {
    taskStore.addTask(task.value);
  }
  resetForm();
  emits("closeDialog");
};

const resetForm = () => {
  task.value = {
    name: "",
    description: "",
    is_done: false,
  };
};

const isEditing = computed(() => {
  return task.value.id >= 0;
});
</script>

<template>
  <q-dialog persistent>
    <q-card style="width: 90vw" class="q-px-sm q-pb-md">
      <q-card-section>
        <div class="text-h6 flex align-middle justify-between">
          {{ isEditing ? "Editar Tarefa" : "Nova Tarefa" }}
          <q-btn flat @click="emits('closeDialog')">
            <q-icon name="mdi-close"></q-icon>
          </q-btn>
        </div>
      </q-card-section>

      <div class="q-pa-md">
        <q-form @submit="onSubmit" class="q-gutter-md">
          <q-input
            filled
            v-model="task.name"
            label="Nome *"
            hint="Nome da tarefa"
            lazy-rules
            :rules="[
              (val) => (val && val.length > 0) || 'Informe o nome da tarefa',
            ]"
          >
            <template v-slot:prepend>
              <q-icon name="mdi-calendar-edit"></q-icon>
            </template>
          </q-input>
          <q-input
            filled
            v-model="task.description"
            type="textarea"
            label="Descrição"
            hint="Descrição da tarefa"
          >
            <template v-slot:prepend>
              <q-icon name="mdi-calendar-blank"></q-icon>
            </template>
          </q-input>
          <div v-if="isEditing" class="text-left">
            <q-btn
              @click="deleteTask"
              icon="mdi-delete"
              flat
              label="Excluir Tarefa"
              color="red"
            />
          </div>
          <div class="text-right">
            <q-btn label="Salvar" type="submit" color="primary" />
          </div>
        </q-form>
      </div>
    </q-card>
  </q-dialog>
</template>
